##
##  vulcand.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_vulcand_base 0.9.0
%define       V_vulcand_snap 20200828

#   package information
Name:         vulcand
Summary:      Reverse Proxy Based on EtcD
URL:          https://vulcand.io/
Vendor:       Mailgun
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Networking
License:      MIT
Version:      %{V_vulcand_base}.%{V_vulcand_snap}
Release:      20200828

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/vulcand/vulcand-%{V_vulcand_snap}.tar.xz
Source1:      rc.vulcand

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, go
PreReq:       OpenPKG, openpkg >= 20160101, etcd

%description
    Vulcand is a reverse proxy for HTTP API management and
    microservices. It is inspired by Hystrix. It uses Etcd as a
    configuration backend, so changes to configuration take effect
    immediately without restarting the service.

%track
    prog vulcand = {
        version   = %{V_vulcand_base}
        url       = https://github.com/mailgun/vulcand/releases
        regex     = v(__VER__)\.tar\.gz
    }

%prep
    %setup -q -n vulcand

%build
    export GOPATH=`pwd`
    cd src/github.com/mailgun/vulcand
    go build -x -o bin/vulcand
    go build -x -o bin/vctl vctl/main.go

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/sbin \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d \
        $RPM_BUILD_ROOT%{l_prefix}/var/vulcand/run \
        $RPM_BUILD_ROOT%{l_prefix}/var/vulcand/log
    %{l_shtool} install -c -s -m 755 \
        src/github.com/mailgun/vulcand/bin/vulcand \
        src/github.com/mailgun/vulcand/bin/vctl \
        $RPM_BUILD_ROOT%{l_prefix}/sbin/
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE rc.vulcand} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%attr(-,%{l_rusr},%{l_rgrp}) %{l_prefix}/var/vulcand/*'

%files -f files

%clean

